###############################################################################
#                                                                             #
# PicasaGallery.pm  by XTC                                                    #
#                                                                             #
###############################################################################
#                                                                             #
# Version:        Beta 1				                      #
# Date:           12 / 2014                                                   #
# Distributed by: http://www.yabbserver.com                                   #
#                                                                             #
# =========================================================================== #
#                                                                             #
# NOTE: Picasa is a registered trademark of Google Inc.                       #
#       The author declines every responsability about this software          #
#                                                                             #
# =========================================================================== #
#                                                                             #
# Copyright (c) 2014 YaBB Server (www.yabbserver.com) - All Rights Reserved.  #
#       The author declines every responsability about this software          #
#                                                                             #
###############################################################################

$picasagallerypmver = 'Picassa Gallery Beta 2';
if ( $action eq 'detailedversion' ) { return 1; }
use CGI::Carp qw(fatalsToBrowser);
LoadLanguage("Mods/PicasaGallery");

#<----------------------------------------------->#
# MAIN PROGRAM
#<----------------------------------------------->#

use LWP::Simple;

if ( $INFO{'picasaid'} || $FORM{'picasaid'} ) {
	$picasaid = $INFO{'picasaid'} || $FORM{'picasaid'}; 
}

$pic_gallery = qq~<a href="$scripturl?picasaid=$picasaid" title="$gallery{'2'}"><img src="$yyhtml_root/PicasaGallery/picasa.png" alt="" /></a>~;
$picasaurlimg = qq~<img src="$yyhtml_root/PicasaGallery/picasaurl.png" alt="" />~;
$galleriaimg = qq~<img src="$yyhtml_root/PicasaGallery/galleria.png" alt="" />~;
$flashimg = qq~<img src="$yyhtml_root/PicasaGallery/flash.png" alt="" />~;
$photoindeximg = qq~<img src="$yyhtml_root/PicasaGallery/photoindex.png" alt="" />~;
$photolinkimg = qq~<img src="$yyhtml_root/PicasaGallery/photolink.png" alt="" />~;
$photoimg = qq~<img src="$yyhtml_root/PicasaGallery/photo.png" alt="" />~;
$infoimg = qq~<img src="$yyhtml_root/PicasaGallery/info.png" alt="" />~;

$yyinlinestyle .= qq~
<link href="$yyhtml_root/PicasaGallery/gallery.css" rel="stylesheet" type="text/css" />
<script language="JavaScript" type="text/javascript">
    <!--
	function picasadirect(seite){
		window.open(seite,"_blank");
	}
    //-->
</script> 
~;

#<----------------------------------------------->#
# Gallery access check
#<----------------------------------------------->#

	if (!$picasagroups) { fatal_error( q{}, "$gallery{'27'}" ); }
	if ($iamguest && $picasagroups > 1) { fatal_error('no_access'); }
	if ($picasagroups  == 3 && !$iamadmin && !$iamgmod && !$iammod) { fatal_error('no_access'); }
	if ($picasagroups  == 4 && !$iamadmin && !$iamgmod) { fatal_error('no_access');; }
	my $access_to_gallery = 0;
	if ($iamadmin) { $access_to_gallery = 1; }
	elsif ( $picasamemgroups eq q{} ) { $access_to_gallery = 1; }
	elsif ( $iamguest && $picasamemgroups ) { $access_to_gallery = 0; }
	else {
		foreach my $gall_gr (split(/, /, $picasamemgroups)) {
			if ($gall_gr eq ${$uid.$username}{'position'}) { $access_to_gallery = 1; last; }
			foreach (split(/,/, ${$uid.$username}{'addgroups'})) {
				if ($gall_gr eq $_) { $access_to_gallery = 1; last; }
			}
		}
	}
	if (!$access_to_gallery) { fatal_error('no_access'); }

#<----------------------------------------------->#
# Gallery Overview
#<----------------------------------------------->#

sub PicasaGallery {

$thumb_box_width = ($thumb_alb_size + 10) ."px";
if ( $thumb_alb_c_u eq 'c' ) { $thumb_box_width = $thumb_alb_size . "px"; }

my $alb_display = 'display:inline';
        if ( $ENV{'HTTP_USER_AGENT'} =~ /opera/ism ) {
            $alb_display = 'display:inline-block';
        }
        elsif ( $ENV{'HTTP_USER_AGENT'} =~ /firefox/ism ) {
            $alb_display = 'display:inline-block';
}


my $feedurl = "https://picasaweb.google.com/data/feed/base/user/$picasaid?alt=rss&hl=$piclangcode&kind=album&imgmax=1600&thumbsize=$thumb_alb_size$thumb_alb_c_u";
my $picasacontent = get($feedurl);
$picasacontent =~ s/\n/ /g;
$picasacontent =~ s/\r/ /g;
$picasacontent =~ s/\r\n/ /g;

	@totalResults = $picasacontent =~ /<openSearch:totalResults>(.*?)<\/openSearch:totalResults>/g;

$res=0;
while ($res<(1*2)){
	$picasResults .= qq~$totalResults[$res]~;
	$res+=2;
}

$i=0;
$albumzahl=1;
while ($i<$picasResults){

if ( $picasacontent =~ /<item><guid isPermaLink='.*?'>(.*?)<\/guid><pubDate>(.*?)<\/pubDate><atom:updated>.*?<\/atom:updated><category domain='.*?'>.*?<\/category><title>(.*?)<\/title><description>(.*?)<\/description><link>(.*?)<\/link><author>(.*?)<\/author><media:group><media:content url='(.*?)' type='(.*?)' medium='(.*?)'\/><media:credit>(.*?)<\/media:credit>(.*?)<media:keywords.*?<media:thumbnail url='(.*?)' height='(.*?)' width='(.*?)'\/><media:title type='.*?'>(.*?)<\/media:title><\/media:group>/g ) {
	$alb_piclink = $1;
	$alb_pubDate = $2;
	$alb_title = $3;
	$alb_description = $4;
	$alb_link = $5;
	$alb_autor = $6;
	$alb_media_content_url = $7;
	$alb_media_content_type = $8;
	$alb_media_content_medium = $9;
	$alb_media_credit = $10;
	$alb_media_description = $11;
	$alb_media_thumbnail_url = $12;
	$alb_media_thumbnail_height = $13;
	$alb_media_thumbnail_width = $14;
	$alb_media_title = $15;
}
				
$alb_media_thumbnail_height = $alb_media_thumbnail_height ."px";
$alb_media_thumbnail_width = $alb_media_thumbnail_width ."px";

FromHTML($alb_description);

if ( $alb_description =~ /color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><font color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><font color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><p/g ) {
	$location_value = $1;
	$location_photos = $2;
	$date_value = $3;
	$date_upload = $4;
	$number_value = $5;
	$number_photos = $6;
}

if ( $alb_description =~ /color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><font color=".*?">(.*?)<\/font><font color=".*?">(.*?)<\/font><br\/><p/g ) {
	$date_value = $1;
	$date_upload = $2;
	$number_value = $3;
	$number_photos = $4;
	$location_value = qq~~;
	$location_photos = qq~~;
}

if ( $alb_media_description =~ /<media:description type='.*?'>(.*?)</g ) {
	$media_description = $1;
	$media_description =~ s/"/&quot;/g;
	$alb_media_description = qq~<li><b>$gallery{'3'}</b><br />$media_description</li>~;
}

$alblink = rindex($alb_media_thumbnail_url,"/") + 1;
$alblink1 = substr($alb_media_thumbnail_url,$alblink);
( $albumlink, $alblinkex ) = split /\./xsm, $alblink1;

$albid = rindex($alb_piclink,"/") + 1;
$albid1 = substr($alb_piclink,$albid);
( $album_id, $albidex ) = split /\?/xsm, $albid1;

if ( $alb_link =~ /https:\/\/picasaweb.google.com\/(.*?)\/.*?/g ) {
	$picasa_user_id = $1;
	$picasaid = $picasa_user_id;
}

        $quicklinks = qq~<div style="position:relative;$alb_display">
            <ul id="$album_id" class="QuickLinks" onmouseover="keepLinks('$album_id')" onmouseout="TimeClose('$album_id')">
                <li><b>$alb_title</b></li>
                <li><b>$gallery{'4'}</b> $number_photos</li>
                <li><b>$gallery{'5'}</b> $date_upload</li>
                <li><b>$gallery{'6'}</b> $album_id</li>
                <li><b>$gallery{'7'}</b> $alb_media_credit</li>~;
if ($location_photos) {
        $quicklinks .= qq~
                <li><b>$gallery{'8'}</b> $location_photos</li>~;
}
        $quicklinks .= qq~
		$alb_media_description
        	</ul><a href="javascript:quickLinks('$album_id')">$infoimg</a></div>~;

        $albumup_options .= qq~
		<option value="$alb_title">$alb_title</option>\n~;

	$picasacalls .= qq~
		<div class="small" id="hardShade" style="display: inline-block; width: $thumb_box_width; margin: 5px; padding: 10px;  margin-bottom:50px">
                    <b>$alb_title</b> (<i>$number_photos</i>)<br /><br />
		    <form action="$scripturl?action=galleryphoto" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$album_id" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="media_description" value="$media_description" />
	~;
if ( $thumb_alb_c_u eq 'c' ) {
		$picasacalls .= qq~
			<input type="submit" style="background-image:url($alb_media_thumbnail_url); width:$alb_media_thumbnail_width; height:$alb_media_thumbnail_height; border: 0;" title="$gallery{'9'} '$alb_title' $gallery{'10'}" alt="$gallery{'9'} '$alb_title' $gallery{'10'}" name="submit" value="" />
	~;
} else {
		$picasacalls .= qq~
			<input type="image" style="display: block; margin: 0 auto" src="$alb_media_thumbnail_url" title="$gallery{'9'} '$alb_title' $gallery{'10'}" alt="$gallery{'9'} '$alb_title' $gallery{'10'}" name="submit" value="" />
	~;
}
		$picasacalls .= qq~
                    <br /><br />
                    <div style="float: left;  margin-right: 5px;">
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/photoindex.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'10'}" alt="$gallery{'9'} '$alb_title' $gallery{'10'}" name="submit" value="" />
                    </div>
		    </form>
                    <div style="float: left;">
	~;
if ( $linkgalleria ) {
		$picasacalls .= qq~
		    <form action="$scripturl?action=galleryplugin" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$albumlink" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="plugin" value="galleria" />
			<input type="hidden" name="photos" value="$number_photos" />
			<input type="hidden" name="media_description" value="$media_description" />
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/galleria.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'11'}" alt="$gallery{'9'} '$alb_title' $gallery{'11'}" name="submit" value="" />
		    </form>
	~;
}
if ( $linkdivviewer ) {
		$picasacalls .= qq~
		    <form action="$scripturl?action=galleryplugin" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$album_id" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="plugin" value="divviewer" />
			<input type="hidden" name="media_description" value="$media_description" />
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/photo.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'12'}" alt="$gallery{'9'} '$alb_title' $gallery{'12'}" name="submit" value="" />
		    </form>
	~;
}
if ( $linkpicasaflash ) {
		$picasacalls .= qq~
		    <form action="$scripturl?action=galleryplugin" method="post">
			<input type="hidden" name="picasaid" value="$picasaid" />
			<input type="hidden" name="album" value="$album_id" />
			<input type="hidden" name="album_ti" value="$alb_title" />
			<input type="hidden" name="plugin" value="flash" />
			<input type="hidden" name="photos" value="$number_photos" />
			<input type="hidden" name="media_description" value="$media_description" />
			<input type="submit" style="background-image:url($yyhtml_root/PicasaGallery/flash.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'13'}" alt="$gallery{'9'} '$alb_title' $gallery{'13'}" name="submit" value="" />
		    </form>
	~;
}
if ( $linkpicasa ) {
		$picasacalls .= qq~
		    <form>
			<input type="button" style="background-image:url($yyhtml_root/PicasaGallery/picasaurl.png); width:16px; height:16px; border:0;" title="$gallery{'9'} '$alb_title' $gallery{'14'}" alt="$gallery{'9'} '$alb_title' $gallery{'14'}" name="submit" value="" onClick="picasadirect('https://picasaweb.google.com/$picasaid/$albumlink?hl=$piclangcode&noredirect=1')" />
		    </form>
	~;
}
		$picasacalls .= qq~
                    </div>
                    <div style="float: left;  margin-left: 5px;">
                        $quicklinks
                    </div>
		</div>
	~;
	$i++;
	$albumzahl++;
}



if ( -e "$vardir/gallery_header.txt" && $show_gallery_header ) {
    fopen( GALHEADER, "$vardir/gallery_header.txt" ) || fatal_error( 'cannot_open', 'gallery_header.txt', 1 );
        @galleryheader = <GALHEADER>;
    fclose( GALHEADER );

        @gallery_header = join q{}, @galleryheader;
	$gallery_header[0] =~ s/\n/ /g;

	if ( $gallery_header[0] =~ /\[$picasaid\](.*?)\[\/$picasaid\]/g ) { $the_gallery_header = $1; } else { $the_gallery_header = $gallery_header[0]; }
	$gallery_header .= qq~
		<tr>
		 <td class="windowbg2 left">
			$the_gallery_header
		 </td>
		</tr>
	~;
} else {
	$gallery_header .= qq~
		<tr>
		 <td class="nav h_30px">&nbsp;</td>
		</tr>
	~;
	}

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'2'}</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
		$gallery_header
		<tr>
		 <td class="catbg" style="padding: 8px;">
			<b>$gallery{'17'} ($picasResults)</b>
		 </td>
		</tr>
		<tr>
		 <td class="windowbg2 left">
			$picasacalls
		 </td>
		</tr>
		 
	~;

	$yymain .= qq~
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	function picuploadwin() {
        	window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	}
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a>	 
                 </td>
		</tr>
	</table>
	<br /><br />~;

if ( $picasalinks ) {

if ($accept_permalink == 1) {
  $link_to_perma = qq~
<form name="link3">
  <tr>
    <td class="windowbg2"><label for="link_perma"><span class="small" style="font-weight: bold; cursor: pointer;">$link_topic_txt{'05'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_perma" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="http://$perm_domain/$symlink$permdate/$picasaid" title="$link_topic_txt{'09'}" readonly="readonly" /></td>
  </tr>
</form>~;
}

	$yymain .= qq~
  <table class="tabtitle pad_4px">
  <tr>
    <td colspan="2" style="padding-left:1px"><img src="$yyhtml_root/PicasaGallery/photoindex.png" alt="" /> $link_gallery_txt{'10'}</td>
  </tr>
  </table>
  <table class="pad_4px">
	<col width="10%" />
	<col width="90%" />
<form name="link0">
  <tr>
    <td class="windowbg2"><label for="link_html"><span class="small" style="font-weight: bold; cursor: pointer; white-space: nowrap;">$link_gallery_txt{'02'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_html" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="&lt;a href=&quot;$scripturl?picasaid=$picasaid&quot; target=&quot;_blank&quot;&gt;$gallery{'1'}&lt;/a&gt;" title="$link_gallery_txt{'06'}" readonly="readonly" /></td>
  </tr>
</form>
<form name="link1">
  <tr>
    <td class="windowbg2"><label for="link_bbcode"><span class="small" style="font-weight: bold; cursor: pointer;">$link_gallery_txt{'03'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_bbcode" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="&#91;url=$scripturl?picasaid=$picasaid&#93;$gallery{'1'}&#91;/url&#93;" title="$link_gallery_txt{'07'}" readonly="readonly" /></td>
  </tr>
</form>
<form name="link2">
  <tr>
    <td class="windowbg2"><label for="link_url"><span class="small" style="font-weight: bold; cursor: pointer;">$link_gallery_txt{'04'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_url" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="$scripturl?picasaid=$picasaid" title="$link_gallery_txt{'08'}" readonly="readonly" /></td>
  </tr>
</form>
$link_to_perma
</table>
<br /><br />
	~;
}

if ($emailupload && $iamadmin ) {

$upload_select = qq~
	<select name="album_ti" id="album_ti" size="1">
	    <option value="">$gallery{'33'}</option>
	    $albumup_options
	</select>~;

    $i = 0;
    my $add_icon = 1;

	$yymain .= qq~
<form action="$scripturl?action=galleryupload" method="post" name="upload" onsubmit="return CheckAblumField();" enctype="multipart/form-data" accept-charset="$yymycharset">
  <table class="tabtitle pad_4px">
  <tr>
    <td colspan="3" style="padding-left:1px"><img src="$yyhtml_root/PicasaGallery/photoindex.png" alt="" /> $gallery{'28'}</td>
  </tr>
  </table>
  <table class="pad_4px">
		<tr>
                    <td class="windowbg2 right" style="white-space:nowrap">$upload_select <input type="file" name="caliimg[$i]" id="uploimg[$i]" size="35" /> <span class="cursor small bold" title="$gallery{'30'}" onclick="document.getElementById('uploimg[$i]').value='';">X</span></td>
                    <td class="windowbg2 left"><span class="small">$gallery{'31'}</span></td>
                    <td class="windowbg2 center" colspan="2">
                        <img src="$imagesdir/cat_expand.png" alt="$gallery{'29'}" title="$gallery{'29'}" class="cursor" style="visibility: visible;" id="add_icon$i" onclick="addIcons($add_icon);" />
                        <img src="$imagesdir/cat_collapse.png" alt="" style="visibility: hidden;" /> <!-- Used only for alignment purposes -->
                    </td>
                </tr>~;
    for ( 1 .. 3 ) {
        $i++;
        $add_icon++;
        $yymain .= qq~<tr id="add_icons$i" style="display: none;">
                    <td class="windowbg2 right"><input type="file" name="uploimg[$i]" id="uploimg[$i]" size="35" /> <span class="cursor small bold" title="$gallery{'30'}" onclick="document.getElementById('uploimg[$i]').value='';">X</span></td>
                    <td class="windowbg2 left"><span class="small">$gallery{'31'}</span></td>
                    <td class="windowbg2 center" colspan="2">
                        <img src="$imagesdir/cat_expand.png" alt="$gallery{'29'}" title="$gallery{'29'}" class="cursor" style="visibility: visible;" id="add_icon$i" onclick="addIcons($add_icon);" />
                        <img src="$imagesdir/cat_collapse.png" alt="$gallery{'30'}" title="$gallery{'30'}" class="cursor" style="visibility: visible;" id="col_icon$i" onclick="removeIcons($i);" />
                    </td>
                </tr>~;
    }

    $yymain .= qq~
            </table>
              <table class="pad_4px">
                <tr>
                    <td class="catbg center small">
                        <input type="hidden" name="locAlb" value="0" />
                        <input type="hidden" name="picasaid" value="$picasaid" />
                        <input type="hidden" name="album" value="$useralbum" />
                        <input type="hidden" name="picimg_count" value="$i" />
                        <input type="submit" value="$maintxt{'900s'}" class="button" />
                    </td>
                </tr>
            </table>
<script type="text/javascript">
ic_added = $added_icons + 1;

function addIcons(addic_id) {
    var curic_id = addic_id - 1;
    var ic_count = $i;
    document.getElementById('add_icons' + addic_id).style.display = 'table-row';
    document.getElementById('add_icon' + curic_id).style.visibility = 'hidden';
    if (addic_id != ic_added) {
        document.getElementById('col_icon' + curic_id).style.visibility =' hidden';
    }
    if (addic_id == ic_count) {
        document.getElementById('add_icon' + ic_count).style.visibility = 'hidden';
    }
}
function removeIcons(remic_id) {
    var previc_id = remic_id - 1;
    document.getElementById('add_icons' + remic_id).style.display = 'none';
    document.getElementById('add_icon' + previc_id).style.visibility = 'visible';
    if (remic_id != ic_added) {
        document.getElementById('col_icon' + previc_id).style.visibility = 'visible';
    }
    ic_elements = ["uploimg"];
    for (var i=0; i<ic_elements.length; i++) {
        document.getElementById(ic_elements[i] + '[' + remic_id + ']').value = '';
    }
}
function CheckAblumField() {
if (document.upload.album_ti.value == '') {
    alert("$gallery{'34'}");
    document.upload.album_ti.focus();
    return false;
}
return true;
}
</script>
<br /><br />
        </form>~;
}

	template();
	exit;
}

#<----------------------------------------------->#
# Photo Index
#<----------------------------------------------->#

sub GalleryPhoto {

$useralbum = $FORM{'album'} || $INFO{'album'};
$picasaid = $FORM{'picasaid'} || $INFO{'picasaid'};
$useralbumtitle = $FORM{'album_ti'} || $INFO{'title'};


if ( $useralbum eq q{} ) {
	$yySetLocation = qq~$scripturl?action=gallery~;
    redirectexit();
}
$media_description = $FORM{'media_description'};

        my $pic_display = 'display:inline';
        if ( $ENV{'HTTP_USER_AGENT'} =~ /opera/ism ) {
            $pic_display = 'display:inline-block';
        }
        elsif ( $ENV{'HTTP_USER_AGENT'} =~ /firefox/ism ) {
            $pic_display = 'display:inline-block';
        }

$thumb_box_width = ($thumb_index_size - 15) ."px";

my $feedurl = "https://picasaweb.google.com/data/feed/base/user/$picasaid/albumid/$useralbum?alt=rss&start-index=1&max-results=1000&hl=$piclangcode&kind=photo&imgmax=1600&thumbsize=$thumb_index_size$thumb_index_c_u";
my $picasacontent = get($feedurl);

	@totalResults = $picasacontent =~ /<openSearch:totalResults>(.*?)<\/openSearch:totalResults>/g;

$res=0;
while ($res<(1*2)){
	$picasResults = qq~$totalResults[$res]~;
	$res+=2;
}
$dvviewer=0;
$i=0;
$albumzahl=1;
$gal_pic_row=1;
while ($i < $picasResults){

if ( $picasacontent =~ /<item>.*?<title>(.*?)<\/title><description>(.*?)<\/description><enclosure type='.*?' url='(.*?)' length='.*?'\/><link>(.*?)<\/link><media:group><media:content url='(.*?)' height='(.*?)' width='(.*?)' type='(.*?)' medium='(.*?)'\/><media:credit>(.*?)<\/media:credit>(.*?)<media:keywords.*?<media:thumbnail url='(.*?)' height='(.*?)' width='(.*?)'.*?<media:title type='plain'>(.*?)<\/media:title><\/media:group>/g ) {
	$pic_title = $1;
	$pic_description = $2;
	$pic_enclosure_url = $3;
	$pic_link = $4;
	$pic_media_content_url = $5;
	$pic_media_content_height = $6;
	$pic_media_content_width = $7;
	$pic_media_content_type = $8;
	$pic_media_content_medium = $9;
	$pic_media_credit = $10;
	$pic_media_description = $11;
	$pic_media_thumbnail_url = $12;
	$pic_media_thumbnail_height = $13;
	$pic_media_thumbnail_width = $14;
	$pic_media_title = $15;
}

if ( $pic_media_description =~ /<media:description type='.*?'>(.*?)</g ) {
	$pic_media_description = qq~<li><b>$gallery{'22'}</b><br />$1</li>~;
}

FromHTML($pic_description);

if ( $pic_description =~ /<table><tr><td style=".*?"><a href=".*?"><img style=".*?" src=".*?" alt=".*?"\/><\/a><\/td><td valign=".*?"><font color=".*?">.*?<\/font><font color=".*?">(.*?)<\/font><br\/><font color=\\".*?\\">.*?<\/font><font color=\\".*?\\">(.*?)<\/font><br\/><p><a href=".*?"><font color=".*?">.*?<\/font><\/a><\/p><\/td><\/tr><\/table>/g ) {
	$date_upload = $1;
	$number_comment = $2;
}

$picid = rindex($pic_link,"/") + 1;
$picid1 = substr($pic_link,$picid);
( $picidex, $pic_id ) = split /\#/xsm, $picid1;

        $quicklinks = qq~<div class="left" style="position:relative;$pic_display">
            <ul id="$pic_id" class="QuickLinks" onmouseover="keepLinks('$pic_id')" onmouseout="TimeClose('$pic_id')">
                <li><b>$pic_title</b></li>
                <li>$gallery{'25'} $number_comment</li>
                <li>$gallery{'5'} $date_upload</li>
                <li>$gallery{'26'} $pic_id</li>
                <li>$gallery{'7'} $pic_media_credit</li>
		<li><a href="$pic_media_content_url" data-rel="gb_image[nice_pics]" title="$pic_title" >$gallery{'18'}</a></li>
		$pic_media_description
        </ul><a href="javascript:quickLinks('$pic_id')">$infoimg</a></div>~;


	$picasacalls .= qq~
		<div class="center" style="display: inline-block;">
		<a href="$pic_media_content_url" data-rel="gb_imageset[nice_pics]" title="$pic_title" ><img class="hardShadeimg" src="$pic_media_thumbnail_url" border="0" /></a>
		<br />
		<div class="small right" id="hardShade" style="display: inline-block; width: $thumb_box_width; margin: 5px; padding: 10px; margin-bottom:50px">
		    <a href="$pic_media_content_url" data-rel="gb_imageset[nice_picsa]" title="$pic_title" >$photoindeximg</a>

	~;
if ( $linkpicasaindex ) {
	$picasacalls .= qq~
		    <a href="$pic_media_content_url" target="_blank" title="$gallery{'18'} '$pic_title' $gallery{'24'}" title="$pic_title" >$photolinkimg</a>
	~;
}
	$picasacalls .= qq~
		$quicklinks
                    <span style="float: left;">
                        <b># $albumzahl</b>
                    </span>
		</div>
		</div>
	~;

	$albumzahl++;
	$i++;
}

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'23'} $useralbumtitle ($picasResults)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}
	$yymain .= qq~
		<tr>
		 <td class="windowbg2 left">
			$picasacalls
		 </td>
		</tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>
<br /><br />		 
	~;
if ( $picasalinks ) {
#Link Album Fuction
            $album_urlname = $useralbumtitle;
            $album_urlname =~ s/([^A-Za-z0-9])/sprintf('%%%02X', ord($1))/egxsm;

if ($accept_permalink == 1) {
  $link_to_perma = qq~
<form name="link3">
  <tr>
    <td class="windowbg2"><label for="link_perma"><span class="small" style="font-weight: bold; cursor: pointer;">$link_gallery_txt{'05'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_perma" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="http://$perm_domain/$symlink$permdate/$useralbum/$picasaid/$album_urlname" title="$link_gallery_txt{'09'}" readonly="readonly" /></td>
  </tr>
</form>~;
}

	$yymain .= qq~
  <table class="tabtitle pad_4px">
  <tr>
    <td colspan="2" style="padding-left:1px"><img src="$yyhtml_root/PicasaGallery/photoindex.png" alt="" /> $link_gallery_txt{'01'}</td>
  </tr>
  </table>
  <table class="pad_4px">
	<col width="10%" />
	<col width="90%" />
<form name="link0">
  <tr>
    <td class="windowbg2"><label for="link_html"><span class="small" style="font-weight: bold; cursor: pointer; white-space: nowrap;">$link_gallery_txt{'02'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_html" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="&lt;a href=&quot;$scripturl?action=galleryphoto;album=$useralbum;picasaid=$picasaid;title=$album_urlname&quot; target=&quot;_blank&quot;&gt;$useralbumtitle&lt;/a&gt;" title="$link_gallery_txt{'06'}" readonly="readonly" /></td>
  </tr>
</form>
<form name="link1">
  <tr>
    <td class="windowbg2"><label for="link_bbcode"><span class="small" style="font-weight: bold; cursor: pointer;">$link_gallery_txt{'03'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_bbcode" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="&#91;url=$scripturl?action=galleryphoto;album=$useralbum;picasaid=$picasaid;title=$album_urlname&#93;$useralbumtitle&#91;/url&#93;" title="$link_gallery_txt{'07'}" readonly="readonly" /></td>
  </tr>
</form>
<form name="link2">
  <tr>
    <td class="windowbg2"><label for="link_url"><span class="small" style="font-weight: bold; cursor: pointer;">$link_gallery_txt{'04'}:</span></label></td>
    <td class="windowbg2"><input name="topcode" type="text" id="link_url" class="small" style="width: 98%; cursor: pointer;" onClick="this.form.topcode.select();this.form.topcode.focus();document.execCommand('Copy')" value="$scripturl?action=galleryphoto;album=$useralbum;picasaid=$picasaid;title=$album_urlname" title="$link_gallery_txt{'08'}" readonly="readonly" /></td>
  </tr>
</form>
$link_to_perma
</table>
<br /><br />
	~;
}

if ($emailupload && $iamadmin ) {

    $i = 0;
    my $add_icon = 1;

	$yymain .= qq~
<form action="$scripturl?action=galleryupload" method="post" enctype="multipart/form-data" accept-charset="$yymycharset">
  <table class="tabtitle pad_4px">
  <tr>
    <td colspan="3" style="padding-left:1px"><img src="$yyhtml_root/PicasaGallery/photoindex.png" alt="" /> $gallery{'28'}</td>
  </tr>
  </table>
  <table class="pad_4px">
		<tr>
                    <td class="windowbg2 center" style="white-space:nowrap"><input type="file" name="uploimg[$i]" id="uploimg[$i]" size="35" /> <span class="cursor small bold" title="$gallery{'30'}" onclick="document.getElementById('uploimg[$i]').value='';">X</span></td>
                    <td class="windowbg2 left"><span class="small">$gallery{'31'}</span></td>
                    <td class="windowbg2 center" colspan="2">
                        <img src="$imagesdir/cat_expand.png" alt="$gallery{'29'}" title="$gallery{'29'}" class="cursor" style="visibility: visible;" id="add_icon$i" onclick="addIcons($add_icon);" />
                        <img src="$imagesdir/cat_collapse.png" alt="" style="visibility: hidden;" /> <!-- Used only for alignment purposes -->
                    </td>
                </tr>~;
    for ( 1 .. 3 ) {
        $i++;
        $add_icon++;
        $yymain .= qq~<tr id="add_icons$i" style="display: none;">
                    <td class="windowbg2 center"><input type="file" name="uploimg[$i]" id="uploimg[$i]" size="35" /> <span class="cursor small bold" title="$gallery{'30'}" onclick="document.getElementById('uploimg[$i]').value='';">X</span></td>
                    <td class="windowbg2 left"><span class="small">$gallery{'31'}</span></td>
                    <td class="windowbg2 center" colspan="2">
                        <img src="$imagesdir/cat_expand.png" alt="$gallery{'29'}" title="$gallery{'29'}" class="cursor" style="visibility: visible;" id="add_icon$i" onclick="addIcons($add_icon);" />
                        <img src="$imagesdir/cat_collapse.png" alt="$gallery{'30'}" title="$gallery{'30'}" class="cursor" style="visibility: visible;" id="col_icon$i" onclick="removeIcons($i);" />
                    </td>
                </tr>~;
    }

    $yymain .= qq~
            </table>
              <table class="pad_4px">
                <tr>
                    <td class="catbg center small">
                        <input type="hidden" name="locAlb" value="1" />
                        <input type="hidden" name="picasaid" value="$picasaid" />
                        <input type="hidden" name="album" value="$useralbum" />
                        <input type="hidden" name="album_ti" value="$useralbumtitle" />
                        <input type="hidden" name="picimg_count" value="$i" />
                        <input type="submit" value="$maintxt{'900s'}" class="button" />
                    </td>
                </tr>
            </table>
<script type="text/javascript">
ic_added = $added_icons + 1;

function addIcons(addic_id) {
    var curic_id = addic_id - 1;
    var ic_count = $i;
    document.getElementById('add_icons' + addic_id).style.display = 'table-row';
    document.getElementById('add_icon' + curic_id).style.visibility = 'hidden';
    if (addic_id != ic_added) {
        document.getElementById('col_icon' + curic_id).style.visibility =' hidden';
    }
    if (addic_id == ic_count) {
        document.getElementById('add_icon' + ic_count).style.visibility = 'hidden';
    }
}
function removeIcons(remic_id) {
    var previc_id = remic_id - 1;
    document.getElementById('add_icons' + remic_id).style.display = 'none';
    document.getElementById('add_icon' + previc_id).style.visibility = 'visible';
    if (remic_id != ic_added) {
        document.getElementById('col_icon' + previc_id).style.visibility = 'visible';
    }
    ic_elements = ["uploimg"];
    for (var i=0; i<ic_elements.length; i++) {
        document.getElementById(ic_elements[i] + '[' + remic_id + ']').value = '';
    }
}
</script>
<br /><br />
        </form>~;
}

	template();
	exit;
}

sub GalleryUpload {

if ( !$emailupload && !$iamadmin ) { fatal_error('no_access'); }
if ( !$FORM{'locAlb'} && !$FORM{'album_ti'} ) { fatal_error( '', "$gallery{'34'}" ); }

$useralbum = $FORM{'album'};
$picasaid = $FORM{'picasaid'};
$useralbumtitle = $FORM{'album_ti'};
$album_urlname = $useralbumtitle;
$album_urlname =~ s/([^A-Za-z0-9])/sprintf('%%%02X', ord($1))/egxsm;
$picasamail = 0;

foreach (split(/\|/, $secretuploadmail)) {
   if ( $_ =~ /$picasaid\.(.*?)\@picasaweb.com/g ) {
        $picasa_email = "$picasaid\.$1\@picasaweb\.com"; $picasamail = 1;
   }
}

if ( !$picasamail ) {
        fatal_error( 'invalid_email', "$gallery{'32'}" );
}

    my $count = 0;
    my $tempA = 0;

    $picimg_count = $FORM{'picimg_count'};

    unless (-d "$htmldir/PicasaGallery/upload") {
        mkdir "$htmldir/PicasaGallery/upload",0755;
    }

    for ( 1 .. $picimg_count ) {

            if ( $FORM{"uploimg[$tempA]"} ne q{} ) {
                $FORM{"uploimg[$tempA]"} = UploadFile("uploimg[$tempA]", 'PicasaGallery/upload', 'png jpg jpeg gif', '2000', '0');
		push(@filenames,"$FORM{\"uploimg[$tempA]\"}\n");
		$anhang = 1;
            }

        $tempA++;
    }

#########################
require Modules::MIME::Lite;


    my $msg = MIME::Lite->new(
           To      => $picasa_email,
           From    => ${$uid.$username}{'email'},
           Subject => $FORM{'album_ti'},
           Type    => 'multipart/mixed'
       );

    if( $anhang == 1 ){
    	foreach my $ifile (@filenames){
	chomp($ifile);
    	  if(-e("$htmldir/PicasaGallery/upload\/$ifile")){
            $msg->attach(
                Type     => 'AUTO', # Let it be auto-detected.
                Filename => $ifile,
                Path     => "$htmldir/PicasaGallery/upload/$ifile",
            );
    	  }else{
    		fatal_error( 'cannot_open', "$htmldir/PicasaGallery/upload/$ifile", 1 );
    	  }
    	}
    }

    if ( !$mailtype ) {
           $msg->send();
    } else {
           my @arg = ("$smtp_server", Hello => "$smtp_server", Timeout => 30);
           push(@arg, AuthUser => "$authuser") if $authuser;
           push(@arg, AuthPass => "$authpass") if $authpass;
           $msg->send('smtp', @arg);
    }

    if( $anhang == 1 ){
    	foreach my $ifile (@filenames){
	chomp($ifile);
            unlink "$htmldir/PicasaGallery/upload/$ifile";
    	}
    }

#########################

    if ( $FORM{'locAlb'} == 1 ) {
        $yySetLocation = qq~$scripturl?action=galleryphoto;album=$useralbum;picasaid=$picasaid;title=$album_urlname~;
    }
    else {
        $yySetLocation = "$scripturl?picasaid=$picasaid";
    }
    redirectexit();
    return;

}

#<----------------------------------------------->#
# Plugin Section
#<----------------------------------------------->#

sub GalleryPlugin {

$useralbum = $FORM{'album'};
$picasaid = $FORM{'picasaid'} || $INFO{'picasaid'};
$useralbumtitle = $FORM{'album_ti'};
$pics_in_album = $FORM{'photos'};
$media_description = $FORM{'media_description'};

if ( $useralbum eq q{} ) {
	$yySetLocation = qq~$scripturl?action=gallery~;
    redirectexit();
}

        my $pic_display = 'display:inline';
        if ( $ENV{'HTTP_USER_AGENT'} =~ /opera/ism ) {
            $pic_display = 'display:inline-block';
        }
        elsif ( $ENV{'HTTP_USER_AGENT'} =~ /firefox/ism ) {
            $pic_display = 'display:inline-block';
        }

#<----------------------------------------------->#
# Plugin Div Viewer
#<----------------------------------------------->#

if ($FORM{'plugin'} eq "divviewer") {

$thumb_box_width = "". ($thumb_divviewer_size + 10) ."px";

$yyinlinestyle .= qq~
<script src="$yyhtml_root/PicasaGallery/plugins/divviewer/DV.js" type="text/javascript" charset="ISO-8859-1"></script>
~;

$dvviewer_js = qq~
<script language="JavaScript" type="text/javascript">
	<!--
var myPics = new Array();
~;

my $feedurl = "https://picasaweb.google.com/data/feed/base/user/$picasaid/albumid/$useralbum?alt=rss&start-index=1&max-results=1000&hl=$piclangcode&kind=photo&imgmax=1600&thumbsize=$thumb_divviewer_size$thumb_divviewer_c_u";
my $picasacontent = get($feedurl);

	@totalResults = $picasacontent =~ /<openSearch:totalResults>(.*?)<\/openSearch:totalResults>/g;

$res=0;
while ($res<(1*2)){
	$picasResults = qq~$totalResults[$res]~;
	$res+=2;
}
$dvviewer=0;
$i=0;
$albumzahl=1;
$gal_pic_row=1;
while ($i < $picasResults){

if ( $picasacontent =~ /<item>.*?<title>(.*?)<\/title><description>(.*?)<\/description><enclosure type='.*?' url='(.*?)' length='.*?'\/><link>(.*?)<\/link><media:group><media:content url='(.*?)' height='(.*?)' width='(.*?)' type='(.*?)' medium='(.*?)'\/><media:credit>(.*?)<\/media:credit>(.*?)<media:keywords.*?<media:thumbnail url='(.*?)' height='(.*?)' width='(.*?)'.*?<media:title type='plain'>(.*?)<\/media:title><\/media:group>/g ) {
	$pic_title = $1;
	$pic_description = $2;
	$pic_enclosure_url = $3;
	$pic_link = $4;
	$pic_media_content_url = $5;
	$pic_media_content_height = $6;
	$pic_media_content_width = $7;
	$pic_media_content_type = $8;
	$pic_media_content_medium = $9;
	$pic_media_credit = $10;
	$pic_media_description = $11;
	$pic_media_thumbnail_url = $12;
	$pic_media_thumbnail_height = $13;
	$pic_media_thumbnail_width = $14;
	$pic_media_title = $15;
}

if ( $pic_media_description =~ /<media:description type='.*?'>(.*?)</g ) {
	$pic_media_description = qq~<li><b>$gallery{'22'}</b><br />$1</li>~;
}

FromHTML($pic_description);

if ( $pic_description =~ /<table><tr><td style=".*?"><a href=".*?"><img style=".*?" src=".*?" alt=".*?"\/><\/a><\/td><td valign=".*?"><font color=".*?">.*?<\/font><font color=".*?">(.*?)<\/font><br\/><font color=\\".*?\\">.*?<\/font><font color=\\".*?\\">(.*?)<\/font><br\/><p><a href=".*?"><font color=".*?">.*?<\/font><\/a><\/p><\/td><\/tr><\/table>/g ) {
	$date_upload = $1;
	$number_comment = $2;
}

$picid = rindex($pic_link,"/") + 1;
$picid1 = substr($pic_link,$picid);
( $picidex, $pic_id ) = split /\#/xsm, $picid1;

	$dvviewer_js .= qq~
		myPics[$albumzahl] = '<img src="$pic_media_content_url" width="$pic_media_content_width" height="$pic_media_content_height" border="0" alt="Slide $albumzahl of $picasResults">';
	~;

        $quicklinks = qq~<div class="left" style="position:relative;$pic_display">
            <ul id="$pic_id" class="QuickLinks" onmouseover="keepLinks('$pic_id')" onmouseout="TimeClose('$pic_id')">
                <li><b>$pic_title</b></li>
                <li><b>$gallery{'25'}</b> $number_comment</li>
                <li><b>$gallery{'5'}</b> $date_upload</li>
                <li><b>$gallery{'26'}</b> $pic_id</li>
                <li><b>$gallery{'7'}</b> $pic_media_credit</li>
		<li><a href="#" onClick="DvViewer($albumzahl);return false;" title="$gallery{'18'}: '$pic_title' $gallery{'12'}">$gallery{'18'}</a></li>
		$pic_media_description
        </ul><a href="javascript:quickLinks('$pic_id')">$infoimg</a></div>~;

	$picasacalls .= qq~
		<div class="small left" id="hardShade" style="display: inline-block; width: $thumb_box_width; margin: 5px; padding: 10px;">
                    <b># $albumzahl</b><br /><br />
                    <center><a href="#" onClick="DvViewer($albumzahl);return false;"><img class="hardShadeimg" src="$pic_media_thumbnail_url" border="0" ></a></center><br /><br />
		    <a href="#" onClick="DvViewer($albumzahl);return false;" title="$gallery{'18'} '$pic_title' $gallery{'12'}">$photoindeximg</a> 
		$quicklinks
		</div>
	~;

	$albumzahl++;
	$dvviewer++;
	$i++;
}
	$dvviewer_js .= qq~
function DvViewer(thepic)
{
  //unset array to hide paging
  dv.setAllImagesArray(myPics);
  dv.showDV(myPics[thepic]);
}
	//-->
</script>
	~;

	$yymain .= qq~
	$dvviewer_js
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'19'} $useralbumtitle ($picasResults)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}
	$yymain .= qq~
		<tr>
		 <td class="windowbg2 left">
			$picasacalls
		 </td>
		</tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>		 
	~;
}

#<----------------------------------------------->#
# Plugin Galleria
#<----------------------------------------------->#

if ($FORM{'plugin'} eq "galleria") {

$galleria_box_width = $galleria_width ."px";
$galleria_box_height = $galleria_height ."px";



	$yyinlinestyle .= qq~
<script src="http://ajax.googleapis.com/ajax/libs/jquery/1/jquery.js"></script>
<script type="text/javascript" src="$yyhtml_root/PicasaGallery/plugins/galleria/galleria-1.3.5.min.js"></script>
<script type="text/javascript" src="$yyhtml_root/PicasaGallery/plugins/galleria/picasa/galleria.picasa.min.js"></script>
        <style>
            /* This rule is read by Galleria to define the gallery height: */
            .galleria{width: $galleria_box_width; height:$galleria_box_height;} 
        </style>
~;

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'20'} $useralbumtitle ($pics_in_album)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}
	$yymain .= qq~
		<tr>
		 <td class="windowbg2 left">
			<center><div class="galleria"></div></center>
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	    // Load the classic theme
	    Galleria.loadTheme('$yyhtml_root/PicasaGallery/plugins/galleria/themes/$galleria_theme/galleria.$galleria_theme.min.js');

	    Galleria.run('.galleria', {
	        // The user & album. This example fetches the album "Demo" from the user "galleriajs"
	        picasa: 'useralbum:$picasaid/$useralbum'
	    });
	    Galleria.configure({
	        lightbox: true
	    });
	</script>
		 </td>
		</tr>
		<tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
			<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>
	~;
}

#<----------------------------------------------->#
# Plugin Picasa Flash Slider
#<----------------------------------------------->#

if ($FORM{'plugin'} eq "flash") {

if    ( $picasa_flash_width == 0 ) 	{ 
	$picasa_flash_w  = 144; $picasa_flash_h  = 96;	}
elsif ( $picasa_flash_width == 1 ) 	{ 
	$picasa_flash_w  = 288; $picasa_flash_h  = 192;	}
elsif ( $picasa_flash_width == 2 ) 	{ 
	$picasa_flash_w  = 400; $picasa_flash_h  = 267;	}
elsif ( $picasa_flash_width == 3 ) 	{ 
	$picasa_flash_w  = 600; $picasa_flash_h  = 400;	}
else  { $picasa_flash_w  = 800;
	$picasa_flash_h  = 533;	}

$picasa_flash_color =~ s/#//gsm;
$picasa_fix = ( ( $pics_in_album * 3000 ) + 1300 );

	$yyinlinestyle .= qq~
<script type="text/javascript" src="$yyhtml_root/PicasaGallery/plugins/flash/slideRun.js"></script>
~;

	$yymain .= qq~
	<table class="tabtitle pad_3px">
		<tr>
		 <td>$pic_gallery $gallery{'21'} $useralbumtitle ($pics_in_album)</td>
		</tr>
	</table>
	<table class="bordercolor pad_4px cs_thin" >
	~;
if ($media_description) {
	$yymain .= qq~
		<tr>
		 <td class="windowbg left">
			$media_description
		 </td>
		</tr>
	~;
}

	$yymain .= qq~
		<tr>
		 <td class="windowbg2 center">
			<center><embed type="application/x-shockwave-flash" src="https://picasaweb.google.com/s/c/bin/slideshow.swf" width="$picasa_flash_w" height="$picasa_flash_h" flashvars="host=picasaweb.google.com&hl=$piclangcode&feat=flashalbum&RGB=0x$picasa_flash_color&feed=https%3A%2F%2Fpicasaweb.google.com%2Fdata%2Ffeed%2Fapi%2Fuser%2F$picasaid%2Falbumid%2F$useralbum%3Falt%3Drss%26kind%3Dphoto%26hl%3D$piclangcode" pluginspage="http://www.macromedia.com/go/getflashplayer"></embed><img onerror="slideRun(this,$picasa_fix)" src="..." /></center>
 		 </td>
		</tr>
		<tr>
        	 <td class="catbg left" style="padding: 8px;">
	<script>
	    function picuploadwin() {
	        window.open("https://docs.google.com/picker?protocol=gadgets&relayUrl=https://picasaweb.google.com/s/v/84.17/rpc_relay.html&hostId=pwa&hl=$piclangcode&rpcService=lhid_picker&rpctoken=1g73kb46x4u9q&selectButtonLabel=Ok&navHidden=true&multiselectEnabled=true&white=true&chromeMode=none&nav=((%22upload%22,null,%7B%22cRename%22:%22pname%22,%22query%22:%22photos%22,%22data%22:%7B%22owner_name%22:%22$picasaid%22,%22disable_asbe_notification%22:%22false%22,%22streamid%22:null%7D%7D))", 'list', 'width=800,height=500, scrollbars=yes');
	    }
	</script>
	<a href="javascript:picuploadwin()">$gallery{'15'}</a> <a href="$scripturl?picasaid=$picasaid">$gallery{'16'}</a>
                 </td>
		</tr>
	</table>
	~;
}

	template();
	exit;
}

#<----------------------------------------------->#
# The Happy End :)
#<----------------------------------------------->#

1;
